{*******************************************************}
{                                                       }
{                     HTMLCoolEdit                      }
{                                                       }
{           Copyright (c) 1999-2000 PROFOX              }
{                                                       }
{*******************************************************}

unit About;

interface

uses
  SysUtils, Windows, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Buttons, ExtCtrls;

type
  TAboutBox = class(TForm)
    OKButton: TButton;
    Copyright: TLabel;
    Bevel1: TBevel;
    SKUName: TLabel;
    PhysMem: TLabel;
    OS: TLabel;
    Label3: TLabel;
    Label2: TLabel;
    VersionLabel: TLabel;
    ProfoxImage: TImage;
    UrlHPLabel: TLabel;
    HPLabel: TLabel;
    EMailLabel: TLabel;
    AddrEMailLabel: TLabel;
    Bevel2: TBevel;
    Bevel3: TBevel;
    CaptionImage: TImage;
    procedure FormCreate(Sender: TObject);
    procedure UrlHPLabelClick(Sender: TObject);
    procedure AddrEMailLabelClick(Sender: TObject);
  private
    procedure GetOSInfo;
    procedure InitializeCaptions;
  end;

procedure ShowAboutBox;

implementation

uses ShellAPI, Main, ResWork;

{$R *.DFM}

procedure ShowAboutBox;
begin
  with TAboutBox.Create(Application) do
    try
      ShowModal;
    finally
      Free;
      end;
  end;

procedure TAboutBox.GetOSInfo;
var
  Platform: string;
  BuildNumber: Integer;
begin
  case Win32Platform of
    VER_PLATFORM_WIN32_WINDOWS:
      begin
        Platform := 'Windows 95';
        BuildNumber := Win32BuildNumber and $0000FFFF;
      end;
    VER_PLATFORM_WIN32_NT:
      begin
        Platform := 'Windows NT';
        BuildNumber := Win32BuildNumber;
      end;
      else
      begin
        Platform := 'Windows';
        BuildNumber := 0;
      end;
  end;
  if (Win32Platform = VER_PLATFORM_WIN32_WINDOWS) or
    (Win32Platform = VER_PLATFORM_WIN32_NT) then
  begin
    if Win32CSDVersion = '' then
      OS.Caption := Format('%s %d.%d (Build %d)', [Platform, Win32MajorVersion,
        Win32MinorVersion, BuildNumber])
    else
      OS.Caption := Format('%s %d.%d (Build %d: %s)', [Platform, Win32MajorVersion,
        Win32MinorVersion, BuildNumber, Win32CSDVersion]);
  end
  else
    OS.Caption := Format('%s %d.%d', [Platform, Win32MajorVersion,
      Win32MinorVersion])
  end;

procedure TAboutBox.InitializeCaptions;
var
  MS: TMemoryStatus;
begin
  GetOSInfo;
  MS.dwLength := SizeOf(TMemoryStatus);
  GlobalMemoryStatus(MS);
  PhysMem.Caption := FormatFloat('#,###" KB"', MS.dwTotalPhys div 1024);
  VersionLabel.Caption:=VersionLabel.Caption+MainForm.AppVersion;
  end;

procedure TAboutBox.FormCreate(Sender: TObject);
begin
  Color:=$02C0C0C0;
  ResWork.LoadJPEGFromRes('PROFOX', ProfoxImage.Picture);
  InitializeCaptions;
  end;

procedure TAboutBox.UrlHPLabelClick(Sender: TObject);
begin
  MainForm.ShellExec('','http://www.madra.dp.ua/cooledit/','');
  end;

procedure TAboutBox.AddrEMailLabelClick(Sender: TObject);
begin
  MainForm.ShellExec('','mailto:cooledit@mail.ru','');
  end;

end.

