
{*******************************************************}
{                                                       }
{                     HTMLCoolEdit                      }
{                                                       }
{           Copyright (c) 1999-2000 PROFOX              }
{                                                       }
{*******************************************************}

program HTMLCoolEdit;

uses
  Windows,
  Registry,
  Dialogs,
  comobj,
  Forms,
  Main in 'Main.pas' {MainForm},
  About in 'About.pas' {AboutBox},
  Options in 'Options.pas' {OptForm},
  Splash in 'splash.pas' {SplashForm},
  Files in 'Files.pas',
  FileWork in 'FileWork.pas',
  RegWork in 'RegWork.pas',
  HelpWork in 'HelpWork.pas',
  FindDlg in 'FindDlg.pas' {EdFindDlg},
  ReplDlg in 'ReplDlg.pas' {EdReplDlg},
  HelpSearch in 'HelpSearch.pas' {SetHelpForm},
  multinst in 'multinst.pas',
  ResWork in 'ResWork.pas',
  OpenWeb in 'OpenWeb.pas' {OpenWebForm};

{$R *.RES}

const
  AppVersion     = '1.261';

var
  FShowLogo:boolean;

begin
  if RegWork.CmpAllow1copy and (not multinst.InitInstance) then exit;
  Application.Title := 'HTMLCoolEdit';
  Application.Initialize;
  FShowLogo:=RegWork.CmpShowLogo;
  if FShowLogo then begin
    SplashForm := TSplashForm.Create(Application);
    SplashForm.AppVersion:=AppVersion;
    SplashForm.Show;
    SplashForm.Update;
    end;
  try
    Application.CreateForm(TMainForm, MainForm);
  Application.CreateForm(TOpenWebForm, OpenWebForm);
  except
    on EOleSysError do begin
      MessageDlg('MSIE4+ may not be installed', mtError, [mbOk], 0);
      exit;
      end;
    end;
  Application.CreateForm(TEdFindDlg, EdFindDlg);
  Application.CreateForm(TEdReplDlg, EdReplDlg);
  Application.CreateForm(TSetHelpForm, SetHelpForm);
  MainForm.AppVersion:=AppVersion;
  Application.CreateForm(TOptForm, OptForm);
  if FShowLogo then begin
    SplashForm.Hide;
    SplashForm.Free;
    end;
  Application.Run;
end.
