{*******************************************************}
{                                                       }
{                     HTMLCoolEdit                      }
{                                                       }
{           Copyright (c) 1999-2000 PROFOX              }
{                                                       }
{*******************************************************}

unit HelpWork;

interface

uses
  Classes;

var
  HelpIniError:boolean;
  HelpName:string;
  HelpIniList:TStringList;
  HelpNamesList:TStringList;
  HelpTagsList:TStringList;

procedure HelpIniLoad;
procedure GetHelpNames;
function GetHelpTags(HelpName:string):boolean;
procedure GetTagHelp;
procedure GetHelpIndex;

implementation

uses
  Main, Files, FileWork, Forms, SysUtils, Dialogs;

procedure HelpIniLoad;
var
  HelpIniFileName:string;
begin
  HelpIniError:=false;
  HelpName:='';
  if Assigned(HelpIniList) then HelpIniList.Free;
  HelpIniList:=TStringList.Create;
  if Assigned(HelpNamesList) then HelpNamesList.Free;
  HelpNamesList:=TStringList.Create;
  if Assigned(HelpTagsList) then HelpTagsList.Free;
  HelpTagsList:=TStringList.Create;
  HelpIniFileName:=ExtractFilePath(Application.ExeName)+'help.ini';
  if FileExists(HelpIniFileName) then begin
    HelpIniList.LoadFromFile(HelpIniFileName);
    GetHelpNames;
    if HelpNamesList.Count>0 then
      HelpName:=HelpNamesList.Names[0];
    if (HelpName<>'') and (not GetHelpTags(HelpName)) then begin
      MessageDlg('Error in file "Help.ini"', mtError, [mbOk], 0);
      HelpIniError:=true;
      end;
  end else begin
    //MessageDlg('File "Help.ini" does not found.', mtError, [mbOk], 0);
    HelpIniError:=true;
    end;
  end;

procedure GetHelpNames;
var
  i:integer;
  XStr:string;
begin
  HelpNamesList.Clear;
  i:=0;
  while (i<=HelpIniList.Count-1)and(HelpIniList[i]<>'')do begin
    XStr:=HelpIniList[i];
    if Copy(XStr,0,4)='File' then
      HelpNamesList.Insert(0,Copy(XStr,5,Length(XStr)-4)); //  
    inc(i);
    end;
  end;

function GetHelpTags(HelpName:string):boolean;
var
  i,XInd:integer;
begin
  result:=true;
  HelpTagsList.Clear;
  XInd:=HelpIniList.IndexOf('['+HelpName+']');
  if XInd<>-1 then begin
    i:=XInd+1;
    while (i<=HelpIniList.Count-1)and(HelpIniList[i]<>'')do begin
      HelpTagsList.Add(HelpIniList[i]);
      inc(i);
      end;
    end
  else result:=false;
  end;

procedure GetTagHelp;
var
  i:integer;
  XStr:string;
  XTag:string;
  HelpFile:string;
  LengthXStr:integer;
begin
  if not Assigned(FEdEntry) then exit;
  if HelpName='' then begin
    MessageDlg('You have not help.', mtError, [mbOk], 0);
    exit;
    end;
  with FEdEntry.Editor do begin
    XStr:=Text;
    i:=SelStart+1;
    while i>=2 do
      if (XStr[i-1]='<')or(XStr[i-1]='>') then break
      else dec(i);
    if (i=1)or(XStr[i-1]='>') then begin
      MessageDlg('Where do you see a tag?', mtError, [mbOk], 0);
      exit;
      end;
    XTag:='';
    LengthXStr:=Length(XStr);
    while i<=LengthXStr do
      if (XStr[i]<#65)and not(XStr[i] in ['!','-','#']) then break
      else begin
        XTag:=XTag+XStr[i];
        inc(i);
        end;
    if XTag='' then begin
      MessageDlg('Here is not a tag', mtError, [mbOk], 0);
      exit;
      end;
    XTag:=UpperCase(XTag);
    HelpFile:=HelpTagsList.Values[XTag];
    if HelpFile<>'' then begin
      MainForm.WBrowserNavigate(ExtractFileDir(HelpNamesList.Values[HelpName])+
        '\'+HelpFile);
    end else
      MessageDlg('For "'+ XTag +'" help does not found.', mtError, [mbOk], 0);
    end;
  end;

procedure GetHelpIndex;
begin
  MainForm.WBrowserNavigate(HelpNamesList.Values[HelpName]);
  end;

end.
