{*******************************************************}
{                                                       }
{                     HTMLCoolEdit                      }
{                                                       }
{           Copyright (c) 1999-2000 PROFOX              }
{                                                       }
{*******************************************************}

unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Menus, Buttons,
  ImgList, shdocvw, ToolWin, OleCtrls, ComCtrls, SyntaxEd, SynParse;

const
  CM_HOMEPAGEREQUEST = WM_USER + $1000;

type
  TCmdLineOption=(NoLogo);
  TCmdLineOptions = set of TCmdLineOption;
  TEditorState=(esNorm,esMin,esMax);
  TSearchAgain=(NoSearch,FindSearch,ReplaceSearch);
  TFileData=record
    FileName:string;
    WordWrap:boolean;
    TopLine:longint;
    CurX,CurY:longint;
    end;
  TBFType=(bfTitle,bfLocation,bfFullPath,bfRelative,bfName);
  TEFType=(efFullPath,efRelative,efName);
  TTitleFormat=record
    PNVisible,BFVisible,EFVisible:boolean;
    BFType:TBFType;
    EFType:TEFType;
    PNIncludeVersion:boolean;
    PNFirst:boolean;
    FFBrowser:boolean;
    end;
  TMainForm = class(TForm)
    MainMenu: TMainMenu;
    MView: TMenuItem;
    MHelp: TMenuItem;
    HAbout: TMenuItem;
    VStatusbar: TMenuItem;
    VRefresh: TMenuItem;
    N2: TMenuItem;
    Splitter1: TSplitter;
    OpenDialog1: TOpenDialog;
    MFile: TMenuItem;
    FExit: TMenuItem;
    N3: TMenuItem;
    FSaveAs: TMenuItem;
    FSave: TMenuItem;
    FOpen: TMenuItem;
    ScrollBox1: TScrollBox;
    RefreshTimer: TTimer;
    MEdit: TMenuItem;
    FNew: TMenuItem;
    FOpenText: TMenuItem;
    VScrollBox: TMenuItem;
    MShortCut: TMenuItem;
    MOptions: TMenuItem;
    OGeneralPreferences: TMenuItem;
    EUndo: TMenuItem;
    N6: TMenuItem;
    ECut: TMenuItem;
    ECopy: TMenuItem;
    EPaste: TMenuItem;
    ESelectAll: TMenuItem;
    MSearch: TMenuItem;
    SFind: TMenuItem;
    SSearchAgain: TMenuItem;
    N7: TMenuItem;
    N4: TMenuItem;
    FReLoad: TMenuItem;
    SaveDialog1: TSaveDialog;
    N5: TMenuItem;
    N9: TMenuItem;
    FReOpen: TMenuItem;
    N10: TMenuItem;
    HHelpCurTag: TMenuItem;
    N11: TMenuItem;
    VChangeFocus: TMenuItem;
    SReplace: TMenuItem;
    VSaveNRefresh: TMenuItem;
    N12: TMenuItem;
    HTMLPanel: TPanel;
    HTMLImageList: TImageList;
    StatusBar1: TStatusBar;
    CMinToolButton: TMenuItem;
    CMaxToolButton: TMenuItem;
    FClose: TMenuItem;
    FCloseAll: TMenuItem;
    CtoBrowserToolButton: TMenuItem;
    CtoEditorToolButton: TMenuItem;
    VSaveAndToBrowser: TMenuItem;
    HTMLParser: TSyntaxMemoParser;
    EReDo: TMenuItem;
    N1: TMenuItem;
    EIndent: TMenuItem;
    EUndent: TMenuItem;
    OEditorOptions: TMenuItem;
    FPrint: TMenuItem;
    SExamples: TMenuItem;
    SEDelFont: TMenuItem;
    SEDelEmptyLines: TMenuItem;
    SEDelUnnecessarySpaces: TMenuItem;
    OParser: TMenuItem;
    PlainTextParser: TSyntaxMemoParser;
    OP1WebDocuments: TMenuItem;
    OP2Plaintext: TMenuItem;
    CSetTab: TMenuItem;
    CS1: TMenuItem;
    CS2: TMenuItem;
    CS9: TMenuItem;
    CS8: TMenuItem;
    CS7: TMenuItem;
    CS6: TMenuItem;
    CS5: TMenuItem;
    CS4: TMenuItem;
    CS3: TMenuItem;
    N13: TMenuItem;
    EDeleteLine: TMenuItem;
    N15: TMenuItem;
    EConvSelCase: TMenuItem;
    ECUpper: TMenuItem;
    ECLower: TMenuItem;
    N16: TMenuItem;
    FConvertTextHTML: TMenuItem;
    FConvertTextRTF: TMenuItem;
    N14: TMenuItem;
    OGroupedUndo: TMenuItem;
    HHelpSetting: TMenuItem;
    N17: TMenuItem;
    FSaveAll: TMenuItem;
    FPPrintAll: TMenuItem;
    FPPrintSelectedBlock: TMenuItem;
    WebBrowser: TWebBrowser;
    CMoveSplitter: TMenuItem;
    CMUp: TMenuItem;
    CMDown: TMenuItem;
    N18: TMenuItem;
    CSPrev: TMenuItem;
    CSNext: TMenuItem;
    CMoveScrollBox: TMenuItem;
    CBUp: TMenuItem;
    CBDown: TMenuItem;
    CBPgUp: TMenuItem;
    CBPgDn: TMenuItem;
    CBHome: TMenuItem;
    CBEnd: TMenuItem;
    CMoveCursorByTags: TMenuItem;
    CTLeft: TMenuItem;
    CTSelLeft: TMenuItem;
    CTMoveSelLeft: TMenuItem;
    CTRight: TMenuItem;
    CTSelRight: TMenuItem;
    CTMoveSelRight: TMenuItem;
    COpenFileUnderCursor: TMenuItem;
    COShell: TMenuItem;
    COEditor: TMenuItem;
    COBrowser: TMenuItem;
    CBrowserNavigate: TMenuItem;
    CNBack: TMenuItem;
    CNForward: TMenuItem;
    FPreviewinBrowser: TMenuItem;
    FBEditBrowserList: TMenuItem;
    N19: TMenuItem;
    FB1BrName: TMenuItem;
    FB2BrName: TMenuItem;
    FB3BrName: TMenuItem;
    FB4BrName: TMenuItem;
    N20: TMenuItem;
    FBDefaultBrowser1: TMenuItem;
    N21: TMenuItem;
    N22: TMenuItem;
    SGotoLineNumber: TMenuItem;
    N8: TMenuItem;
    OAutoRefresh: TMenuItem;
    OWordWrap: TMenuItem;
    N23: TMenuItem;
    OUndoAfterSave: TMenuItem;
    VSaveAllAndRefresh: TMenuItem;
    CMoveFile: TMenuItem;
    CMFilePrev: TMenuItem;
    CMFileNext: TMenuItem;
    HHelpIndex: TMenuItem;
    EditorPopupMenu: TPopupMenu;
    PCut: TMenuItem;
    PCopy: TMenuItem;
    PPaste: TMenuItem;
    PSelectAll: TMenuItem;
    OShowAllChars: TMenuItem;
    N24: TMenuItem;
    CBHorzLeft: TMenuItem;
    CBHorzRight: TMenuItem;
    CBHorzPgUp: TMenuItem;
    CBHorzPgDn: TMenuItem;
    CBHorzHome: TMenuItem;
    CBHorzEnd: TMenuItem;
    SEDelAllTags: TMenuItem;
    VWorkOffline: TMenuItem;
    FOpenWeb: TMenuItem;
    BrowserPanel: TPanel;
    EditorPanel: TPanel;
    HeaderPanel: TPanel;
    FileTabs: TTabControl;
    HTMLToolBar: TToolBar;
    toBrowserToolButton: TToolButton;
    toEditorToolButton: TToolButton;
    ToolButton2: TToolButton;
    MinToolButton: TToolButton;
    MaxToolButton: TToolButton;
    ToolButton5: TToolButton;
    CloseToolButton: TToolButton;
    SQLParser: TSyntaxMemoParser;
    OP3SQL: TMenuItem;
    CStatusBarToClipboard: TMenuItem;
    N25: TMenuItem;
    FB1BrNameWeb: TMenuItem;
    FB2BrNameWeb: TMenuItem;
    FB3BrNameWeb: TMenuItem;
    FB4BrNameWeb: TMenuItem;
    N26: TMenuItem;
    FBDefaultBrowser1Web: TMenuItem;
    procedure FExitClick(Sender: TObject);
    procedure HAboutClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure RefreshClick(Sender: TObject);
    procedure VStatusbarClick(Sender: TObject);
    procedure FOpenClick(Sender: TObject);
    procedure WebBrowserTitleChange(Sender: TObject;
      const Text: WideString);
    procedure OWordWrapClick(Sender: TObject);
    procedure WebBrowserStatusTextChange(Sender: TObject;
      const Text: WideString);
    procedure FormShow(Sender: TObject);
    procedure RefreshTimerTimer(Sender: TObject);
    procedure OGeneralPreferencesClick(Sender: TObject);
    procedure OAutoRefreshClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure SFindClick(Sender: TObject);
    procedure SSearchAgainClick(Sender: TObject);
    procedure FOpenTextClick(Sender: TObject);
    procedure WebBrowserDocumentComplete(Sender: TObject;
      const pDisp: IDispatch; var URL: OleVariant);
    procedure VScrollBoxClick(Sender: TObject);
    procedure Splitter1Moved(Sender: TObject);
    procedure FSaveClick(Sender: TObject);
    procedure EUndoClick(Sender: TObject);
    procedure ECutClick(Sender: TObject);
    procedure ECopyClick(Sender: TObject);
    procedure EPasteClick(Sender: TObject);
    procedure ESelectAllClick(Sender: TObject);
    procedure MEditClick(Sender: TObject);
    procedure MFileClick(Sender: TObject);
    procedure FReLoadClick(Sender: TObject);
    procedure WStateClick(Sender: TObject);
    procedure FSaveAsClick(Sender: TObject);
    procedure FNewClick(Sender: TObject);
    procedure SaveDialog1CanClose(Sender: TObject; var CanClose: Boolean);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure HHelpCurTagClick(Sender: TObject);
    procedure VChangeFocusClick(Sender: TObject);
    procedure SReplaceClick(Sender: TObject);
    procedure VSaveNRefreshClick(Sender: TObject);
    procedure WebBrowserCommandStateChange(Sender: TObject;
      Command: Integer; Enable: WordBool);
    procedure MSearchClick(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure MaxToolButtonClick(Sender: TObject);
    procedure WebBrowserExit(Sender: TObject);
    procedure MinToolButtonClick(Sender: TObject);
    procedure MViewClick(Sender: TObject);
    procedure FCloseClick(Sender: TObject);
    procedure FCloseAllClick(Sender: TObject);
    procedure toBrowserToolButtonClick(Sender: TObject);
    procedure toEditorToolButtonClick(Sender: TObject);
    procedure EReDoClick(Sender: TObject);
    procedure EIndentClick(Sender: TObject);
    procedure EUndentClick(Sender: TObject);
    procedure OEditorOptionsClick(Sender: TObject);
    procedure MOptionsClick(Sender: TObject);
    procedure FPrintClick(Sender: TObject);
    procedure SExamplesClick(Sender: TObject);
    procedure OParserChangeClick(Sender: TObject);
    procedure OParserClick(Sender: TObject);
    procedure FileTabsChanging(Sender: TObject; var AllowChange: Boolean);
    procedure MHelpClick(Sender: TObject);
    procedure CSClick(Sender: TObject);
    procedure EDeleteLineClick(Sender: TObject);
    procedure ECUpperClick(Sender: TObject);
    procedure ECLowerClick(Sender: TObject);
    procedure FConvertTextClick(Sender: TObject);
    procedure OGroupedUndoClick(Sender: TObject);
    procedure HHelpSettingClick(Sender: TObject);
    procedure FSaveAllClick(Sender: TObject);
    procedure FPPrintAllClick(Sender: TObject);
    procedure FPPrintSelectedBlockClick(Sender: TObject);
    procedure CMUpClick(Sender: TObject);
    procedure CMDownClick(Sender: TObject);
    procedure CSPrevClick(Sender: TObject);
    procedure CSNextClick(Sender: TObject);
    procedure CMoveSBoxClick(Sender: TObject);
    procedure CTMoveCurByTagsClick(Sender: TObject);
    procedure COpenFileUnderCursorClick(Sender: TObject);
    procedure CBrowserNavigateClick(Sender: TObject);
    procedure VSaveAndToBrowserClick(Sender: TObject);
    procedure FBBrNameClick(Sender: TObject);
    procedure FPreviewinBrowserClick(Sender: TObject);
    procedure FBDefaultBrowser1Click(Sender: TObject);
    procedure FBEditBrowserListClick(Sender: TObject);
    procedure SGotoLineNumberClick(Sender: TObject);
    procedure OUndoAfterSaveClick(Sender: TObject);
    procedure VSaveAllAndRefreshClick(Sender: TObject);
    procedure FileTabsMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure CMFilePrevClick(Sender: TObject);
    procedure CMFileNextClick(Sender: TObject);
    procedure HHelpIndexClick(Sender: TObject);
    procedure MShortCutClick(Sender: TObject);
    procedure CSetTabClick(Sender: TObject);
    procedure EditorPopupMenuPopup(Sender: TObject);
    procedure OShowAllCharsClick(Sender: TObject);
    procedure VWorkOfflineClick(Sender: TObject);
    procedure FileTabsMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FOpenWebClick(Sender: TObject);
    procedure FileTabsMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure CStatusBarToClipboardClick(Sender: TObject);
    procedure FBDefaultBrowser1WebClick(Sender: TObject);
  private
    memHTMLMemoFocus:boolean;
    memScrollBarPosX,memScrollBarPosY:integer;
    FSearchAgain:TSearchAgain;
    BrowserTitle:string;
    procedure HomePageRequest(var message: tmessage); message CM_HOMEPAGEREQUEST;
    procedure WMActivateApp(var Message: TWMACTIVATEAPP); message WM_ACTIVATEAPP;
    function GroupUndo:longint;
    function GetUndoItem:longint;
    function GroupRedo:longint;
    function GetRedoItem:longint;
    function GetBrFileName(ALocationURL:string):string;
  public
    EditorState:TEditorState;
    SplitterPercent:integer; //Splitter's position (percents)
    AppVersion:string;
    ScrollBoxWidth,ScrollBoxHeight:integer;
    ARDelay:integer;
    SimpleImgToBr:boolean;
    DoNotBrNav:boolean;
    TitleFormat:TTitleFormat;
    B1BrName, B1PathToBr : string; //Browsers
    B2BrName, B2PathToBr : string;
    B3BrName, B3PathToBr : string;
    B4BrName, B4PathToBr : string;
    function ShellExec(ADir,AFile,APar:string):boolean;
    procedure WBrowserNavigate(Url:string);
    procedure FReOpenFileOnClick(Sender: TObject);
    procedure FindAddressLoad(AFileName:string);
    procedure HTMLMemoSetFocus;
    procedure WBSetFocus;
    procedure SetMainFormCaption;
    procedure SetWBrSize;
    procedure SettingsSetDefault;
    function HTMLMemofn_CmpChar(c: Char): Boolean;
    procedure HTMLMemoChange(Sender: TObject);
    procedure HTMLMemoChangeFocus(Sender: TObject);
    procedure HTMLMemoCommandRecognised(Sender: TObject; var ActionCode: Integer);
    procedure HTMLMemoNotification(AEditor:TSyntaxMemo;AOperation:TOperation);
  end;

var
  MainForm: TMainForm;

implementation

uses
  ShellAPI, clipbrd, About, Options, Splash, Files, FileWork, RegWork, HelpWork,
  FindDlg, ReplDlg, HelpSearch, OpenWeb;

{$R *.DFM}

procedure TMainForm.FExitClick(Sender: TObject);
begin
  Close;
  end;

procedure TMainForm.FindAddressLoad(AFileName:string);
begin
  if LoadFileName(AFileName) then begin
    ScrollBox1.HorzScrollBar.Position:=0;
    ScrollBox1.VertScrollBar.Position:=0;
    WBrowserNavigate(FEdEntry.FileName);
    end;
  end;

procedure TMainForm.WBrowserNavigate(Url:string);
var
  Flags: OLEVariant;
begin
  if BrowserPanel.Visible then begin
    WebBrowser.Align:=alClient;
    BrowserPanel.Visible:=false;
    end;
  Flags := 0;
  WebBrowser.Navigate(WideString(Url),Flags,Flags,Flags,Flags);
  toEditorToolButton.Enabled := true;
  end;

procedure TMainForm.WebBrowserDocumentComplete(Sender: TObject;
  const pDisp: IDispatch; var URL: OleVariant);
begin
  //if TWebBrowser(Sender).ReadyState<>READYSTATE_COMPLETE then exit;
  end;

procedure TMainForm.HAboutClick(Sender: TObject);
begin
  ShowAboutBox;
  end;

procedure TMainForm.RefreshClick(Sender: TObject);
var Level: OleVariant;
begin
  Level:=REFRESH_NORMAL;
  if WebBrowser.Document<>nil then WebBrowser.Refresh2(Level);
  end;

procedure TMainForm.VSaveNRefreshClick(Sender: TObject);
begin
  if Assigned(FEdEntry) then FSaveClick(self);
  RefreshClick(self);
  end;

procedure TMainForm.VSaveAllAndRefreshClick(Sender: TObject);
begin
  if Assigned(FEdEntry) then FSaveAllClick(self);
  RefreshClick(self);
  end;

procedure TMainForm.VSaveAndToBrowserClick(Sender: TObject);
begin
  if Assigned(FEdEntry) then FSaveClick(self);
  toBrowserToolButtonClick(self);
  end;

procedure TMainForm.VStatusbarClick(Sender: TObject);
begin
  with VStatusbar do begin
    Checked := not Checked;
    if Checked then StatusBar1.Top:=HTMLPanel.Top+HTMLPanel.Height+1;
    StatusBar1.Visible := Checked;
    end;
  if EditorState=esNorm then Splitter1Moved(self);
  end;

procedure TMainForm.HomePageRequest(var Message: TMessage);
var
  LdFileName:string;
  XFActiveFileExists:boolean;
  memActiveFile:TFileData;
begin
  if EditorState=esMax then begin
    EditorState:=esNorm;
    MaxToolButtonClick(nil)
  end else if EditorState=esMin then begin
    EditorState:=esNorm;
    MinToolButtonClick(nil);
    end;
  XFActiveFileExists:=false;
  if paramcount<>0 then
    LdFileName:=GetParamStrs
  else
    if RegWork.RWGetActiveFile(memActiveFile) then begin
      XFActiveFileExists:=true;
      LdFileName:=memActiveFile.FileName;
    end else LdFileName := ExtractFilePath(Application.ExeName) + 'default.html';
  if LoadFileName(LdFileName) and Assigned(FEdEntry) then begin
    if XFActiveFileExists then begin
      FEdEntry.Editor.WordWrap                   := memActiveFile.WordWrap;
      FEdEntry.Editor.CaretPosition.TopLine      := memActiveFile.TopLine;
      FEdEntry.Editor.CaretPosition.Row          := memActiveFile.CurY;
      FEdEntry.Editor.CaretPosition.OffsetColumn := memActiveFile.CurX;
      end;
    HTMLMemoSetFocus;
    end;
  if not DoNotBrNav then WBrowserNavigate(LdFileName);
  end;

procedure TMainForm.FormCreate(Sender: TObject);

  procedure LoadParsers;
  var
    XSyntaxMemo:TSyntaxMemo;
    XFileStream:TFileStream;
    XStr:string;
  begin
    XStr:=ExtractFilePath(Application.ExeName);
    XSyntaxMemo:=TSyntaxMemo.Create(nil);
    XSyntaxMemo.Visible:=false;
    XSyntaxMemo.Parser1             := HTMLParser;
    XSyntaxMemo.Parser2             := PlainTextParser;
    XSyntaxMemo.Parser3             := SQLParser;
    if FileExists(XStr+'HTMLParser.tpl') then begin
      XSyntaxMemo.ActiveParser:=1;
      XSyntaxMemo.Templates.LoadFromFile(XStr+'HTMLParser.tpl');
      end;
    if FileExists(XStr+'HTMLParser.atr') then begin
      XSyntaxMemo.ActiveParser:=1;
      XFileStream:=TFileStream.Create(XStr+'HTMLParser.atr',fmOpenRead);
      XSyntaxMemo.AutoReplace.LoadFromStream(XFileStream);
      XFileStream.Free;
      end;
    //---
    if FileExists(XStr+'PlainTextParser.tpl') then begin
      XSyntaxMemo.ActiveParser:=2;
      XSyntaxMemo.Templates.LoadFromFile(XStr+'PlainTextParser.tpl');
      end;
    if FileExists(XStr+'PlainTextParser.atr') then begin
      XSyntaxMemo.ActiveParser:=2;
      XFileStream:=TFileStream.Create(XStr+'PlainTextParser.atr',fmOpenRead);
      XSyntaxMemo.AutoReplace.LoadFromStream(XFileStream);
      XFileStream.Free;
      end;
    //---
    if FileExists(XStr+'SQLParser.tpl') then begin
      XSyntaxMemo.ActiveParser:=3;
      XSyntaxMemo.Templates.LoadFromFile(XStr+'SQLParser.tpl');
      end;
   if FileExists(XStr+'SQLParser.atr') then begin
      XSyntaxMemo.ActiveParser:=3;
      XFileStream:=TFileStream.Create(XStr+'SQLParser.atr',fmOpenRead);
      XSyntaxMemo.AutoReplace.LoadFromStream(XFileStream);
      XFileStream.Free;
      end;
    XSyntaxMemo.Free;
    end;

begin
  FileTabs.Tabs.Clear;
  FEdEntry:=nil; //not Assigned
  toEditorToolButton.Enabled:=false;
  Files.ChangeAssignedHTMLMemo;
  FSearchAgain:=NoSearch;
  BrowserTitle:='';
  memScrollBarPosX:=0;
  memScrollBarPosY:=0;
  StatusBar1.TabStop:=false;
  ScrollBox1.TabStop:=false;
  FlRestoreFile:=false;
  HelpWork.HelpIniLoad;
  ReOpenList:=TStringList.Create;
  SettingsSetDefault;
  RegWork.RegistryLoad;
  LoadParsers;
  WindowState:=wsMaximized;
  { Find the home page - needs to be posted because HTML control hasn't been
    registered yet. }
  PostMessage(Handle, CM_HOMEPAGEREQUEST, 0, 0);
  end;

procedure TMainForm.FSaveClick(Sender: TObject);
begin
  FileWork.HTMLMemoSaveToFileName;
  end;

procedure TMainForm.FSaveAsClick(Sender: TObject);
begin
  FileWork.FWSaveAs;
  end;

procedure TMainForm.SaveDialog1CanClose(Sender: TObject;
  var CanClose: Boolean);
begin
  CanClose:=FWSaveDialogCanClose;
  end;

procedure TMainForm.FNewClick(Sender: TObject);
begin
  FileWork.FWNew;
  end;

procedure TMainForm.FOpenClick(Sender: TObject);
begin
  FileWork.FWOpen;
  end;

procedure TMainForm.FOpenWebClick(Sender: TObject);
begin
  OpenWebForm.ShowModal;
  end;

procedure TMainForm.FOpenTextClick(Sender: TObject);
begin
  FileWork.FWOpenText(-1);
  end;

procedure TMainForm.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
var memActiveFile:TFileData;
begin
  if Assigned(FEdEntry) then begin
    with memActiveFile do begin
      FileName := FEdEntry.FileName;
      WordWrap := FEdEntry.Editor.WordWrap; //for get right caret position
      TopLine  := FEdEntry.Editor.CaretPosition.TopLine;
      CurX     := FEdEntry.Editor.CaretPosition.OffsetColumn;
      CurY     := FEdEntry.Editor.CaretPosition.Row;
      end;
    RegWork.RWSetActiveFile(memActiveFile);
    //FEdEntry.Templates.SaveToFile(ExtractFilePath(Application.ExeName) + 'templates.dat';);
    CanClose:=FileWork.CloseAllFiles;
  end else CanClose:=true;
  end;

procedure TMainForm.WebBrowserTitleChange(Sender: TObject;
  const Text: WideString);
begin
  BrowserTitle:=Text;
  SetMainFormCaption;
  end;

procedure TMainForm.SetMainFormCaption;
var XStr,PNStr,BFStr,EFStr:string;
begin
  XStr:=''; PNStr:=''; BFStr:=''; EFStr:='';
  with TitleFormat do begin
    if BFVisible and (WebBrowser.Document<>nil) then begin
      case BFType of
        bfTitle:    BFStr:=BrowserTitle;
        bfLocation: BFStr:=WebBrowser.LocationURL;
        bfFullPath: BFStr:=ExpandFileName(GetBrFileName(WebBrowser.LocationURL));
        bfRelative: if Assigned(FEdEntry) then BFStr:=
                      ExtractRelativePath(ExtractFilePath(FEdEntry.FileName),
                        GetBrFileName(WebBrowser.LocationURL))
                    else BFStr:=ExtractFileName(GetBrFileName(WebBrowser.LocationURL));
        bfName:     BFStr:=ExtractFileName(GetBrFileName(WebBrowser.LocationURL));
        end;
      XStr:='['+BFStr+']';
      end;
    if EFVisible and Assigned(FEdEntry) then begin
      case EFType of
        efFullPath: EFStr:=ExpandFileName(FEdEntry.FileName);
        efRelative: EFStr:=ExtractRelativePath(
                             ExtractFilePath(GetBrFileName(WebBrowser.LocationURL)),
                             FEdEntry.FileName);
        efName:     EFStr:=ExtractFileName(FEdEntry.FileName);
        end;
      if XStr<>'' then
        if FFBrowser then XStr:=XStr+' - ['+EFStr+']'
        else XStr:='['+EFStr+'] - '+XStr
      else XStr:='['+EFStr+']';
      end;
    if PNVisible then begin
      PNStr:='HTMLCoolEdit';
      if PNIncludeVersion then PNStr:=PNStr+' v'+AppVersion;
      if XStr<>'' then
        if PNFirst then XStr:=PNStr+' - '+XStr
        else XStr:=XStr+' - '+PNStr
      else XStr:=PNStr;
      end;
    end;
  if XStr='' then XStr:='HTMLCoolEdit';  
  MainForm.Caption:=XStr;
  Application.Title:=MainForm.Caption;
  end;

procedure TMainForm.OWordWrapClick(Sender: TObject);
begin
  if Assigned(FEdEntry) then begin
    FEdEntry.Editor.WordWrap:=not FEdEntry.Editor.WordWrap;
    Files.FFirst:=true; //refresh StatusBar1
    HTMLMemoChange(self);
    end;
  end;

procedure TMainForm.WebBrowserStatusTextChange(Sender: TObject;
  const Text: WideString);
begin
  Statusbar1.Panels[3].Text := Text;
  Statusbar1.Refresh;
  end;

procedure TMainForm.FormShow(Sender: TObject);
begin
  SetWBrSize;
  end;

procedure TMainForm.FormResize(Sender: TObject);
var
  ClHeight,NewHeight,OldHeight:integer;
begin
  if EditorState=esNorm then begin
    OldHeight:=HTMLPanel.Height;
    ClHeight:=HTMLPanel.Top+HTMLPanel.Height;
    NewHeight:=round((100-SplitterPercent)*ClHeight/100);
    Splitter1.Visible:=false;
    Splitter1.Align:=alNone;
    ScrollBox1.Align:=alNone;
    HTMLPanel.Align:=alNone;
    StatusBar1.Align:=alNone;
    HTMLPanel.Height:=NewHeight;
    HTMLPanel.Top:=HTMLPanel.Top+(OldHeight-NewHeight);
    StatusBar1.Align:=alBottom;
    HTMLPanel.Align:=alBottom;
    ScrollBox1.Align:=alClient;
    Splitter1.Align:=alBottom;
    Splitter1.Visible:=true;
    Splitter1Moved(self);
    end;
  end;

procedure TMainForm.SetWBrSize;
begin
  if VScrollBox.Checked then begin
    WebBrowser.Width:=ScrollBoxWidth;
    WebBrowser.Height:=ScrollBoxHeight;
    end;
  end;

procedure TMainForm.HTMLMemoChange(Sender: TObject);
var
  cPos:TPoint;
begin
  if Assigned(FEdEntry) then begin
    if FEdEntry.Editor.InsertMode
      then StatusBar1.Panels[2].Text:='Insert'
      else StatusBar1.Panels[2].Text:='Overwrite';
    cPos := FEdEntry.Editor.CaretPosition.VisibleLocation;
    if Files.FFirst or (smrcSELECTION in FEdEntry.Editor.ChangeReason) then begin
      with cPos do StatusBar1.Panels[0].Text := format('%4d:%4d ', [Y, X]);
      Files.FFirst:=false;
      end;
    if FEdEntry.Editor.Modified then
      StatusBar1.Panels[1].Text:=' Modified'
    else StatusBar1.Panels[1].Text:='';
    if (smrcTEXT in FEdEntry.Editor.ChangeReason)and
       (OAutoRefresh.Checked) and
       (WebBrowser.ReadyState=READYSTATE_COMPLETE) then begin
      RefreshTimer.Enabled:=false;
      RefreshTimer.Interval:=ARDelay;
      RefreshTimer.Enabled:=true;
      end;
    end
  else begin
    StatusBar1.Panels[0].Text := '';
    StatusBar1.Panels[1].Text := '';
    StatusBar1.Panels[2].Text := '';
    end;
  end;

procedure TMainForm.RefreshTimerTimer(Sender: TObject);
begin
  VSaveAllAndRefreshClick(self);
  RefreshTimer.Enabled:=false;
  end;

procedure TMainForm.OGeneralPreferencesClick(Sender: TObject);
begin
  //OptForm.OptPageControl.ActivePage:=OptForm.GeneralTabSheet;
  OptForm.ShowModal;
  end;

procedure TMainForm.OAutoRefreshClick(Sender: TObject);
begin
  OAutoRefresh.Checked:=not OAutoRefresh.Checked;
  end;

procedure TMainForm.MSearchClick(Sender: TObject);
begin
  SSearchAgain.Enabled:=(FSearchAgain<>NoSearch);
  end;

procedure TMainForm.SFindClick(Sender: TObject);
var
  FindSeed : string;
begin
  if Assigned(FEdEntry) then begin
    FindSeed := FEdEntry.Editor.SelText;
    if pos(#13, FindSeed) > 0 then FindSeed := '';
    if EdFindDlg.Execute(FindSeed, EdFindDlg.FFindOpt) <> mrCancel then begin
      EdFindDlg.DoFind(FEdEntry.Editor);
      FSearchAgain:=FindSearch;
      end;
    end;
  end;

procedure TMainForm.SReplaceClick(Sender: TObject);
var
  FindSeed : string;
begin
  if Assigned(FEdEntry) then begin
    FindSeed := FEdEntry.Editor.SelText;
    if pos(#13, FindSeed) > 0 then FindSeed := '';
    if EdReplDlg.Execute(FindSeed, '', EdReplDlg.FFindOpt) <> mrCancel then begin
      EdReplDlg.DoReplace(FEdEntry.Editor);
      FSearchAgain:=ReplaceSearch;
      end;
    end;
  end;

procedure TMainForm.SSearchAgainClick(Sender: TObject);
begin
  if FSearchAgain<>NoSearch then begin
    if FSearchAgain=FindSearch then EdFindDlg.DoFind(FEdEntry.Editor);
    if FSearchAgain=ReplaceSearch then EdReplDlg.DoReplace(FEdEntry.Editor);
    end;
  end;

procedure TMainForm.SExamplesClick(Sender: TObject);
var XStr1,XStr2:string;
begin
  if Assigned(FEdEntry) then begin
    if Sender=SEDelFont then begin
      XStr1:='<(F|f)(O|o)(N|n)(T|t)([^>]*>)';
      XStr2:='';
      end else
    if Sender=SEDelEmptyLines then begin
      XStr1:='\n{2,}';
      XStr2:='\n';
      end else
    if Sender=SEDelUnnecessarySpaces then begin
      XStr1:='" "{2,}';
      XStr2:=' ';
      end else
    if Sender=SEDelAllTags then begin
      XStr1:='<([^>]*>)';
      XStr2:='';
      end;
    if EdReplDlg.Execute(XStr1, XStr2, EdReplDlg.FFindOpt or ft_REGEXPR) <> mrCancel then begin
      EdReplDlg.DoReplace(FEdEntry.Editor);
      FSearchAgain:=ReplaceSearch;
      end;
    end;
  end;

procedure TMainForm.VScrollBoxClick(Sender: TObject);
begin
  VScrollBox.Checked:=not VScrollBox.Checked;
  if VScrollBox.Checked then begin
    WebBrowser.Align:=alNone;
    SetWBrSize;
    ScrollBox1.HorzScrollBar.Size:=9;
    ScrollBox1.VertScrollBar.Size:=9;
    ScrollBox1.HorzScrollBar.Visible:=true;
    ScrollBox1.VertScrollBar.Visible:=true;
    ScrollBox1.HorzScrollBar.Position:=memScrollBarPosX;
    ScrollBox1.VertScrollBar.Position:=memScrollBarPosY;
  end else begin
    memScrollBarPosX:=ScrollBox1.HorzScrollBar.Position;
    memScrollBarPosY:=ScrollBox1.VertScrollBar.Position;
    ScrollBox1.HorzScrollBar.Visible:=false;
    ScrollBox1.VertScrollBar.Visible:=false;
    ScrollBox1.HorzScrollBar.Size:=0;
    ScrollBox1.VertScrollBar.Size:=0;
    WebBrowser.Align:=alClient;
    end;
  end;

procedure TMainForm.Splitter1Moved(Sender: TObject);
begin
  SplitterPercent:=
    round(ScrollBox1.Height*100/(HTMLPanel.Height+ScrollBox1.Height));
  Splitter1.Hint:=IntToStr(SplitterPercent)+'%';
  end;

procedure TMainForm.ECutClick(Sender: TObject);
begin
  if Assigned(FEdEntry) then
    FEdEntry.Editor.CutToClipboard;
  end;

procedure TMainForm.ECopyClick(Sender: TObject);
begin
  if Assigned(FEdEntry) then
    FEdEntry.Editor.CopyToClipboard;
  end;

procedure TMainForm.EPasteClick(Sender: TObject);
begin
  if Assigned(FEdEntry) then
    FEdEntry.Editor.PasteFromClipboard;
  end;

procedure TMainForm.ESelectAllClick(Sender: TObject);
begin
  if Assigned(FEdEntry) then
    FEdEntry.Editor.SelectAll;
  end;

procedure TMainForm.EIndentClick(Sender: TObject);
begin
  if Assigned(FEdEntry) then
    FEdEntry.Editor.ExecuteCommand(caBLOCKIND,0,false);
  end;

procedure TMainForm.EUndentClick(Sender: TObject);
begin
  if Assigned(FEdEntry) then
    FEdEntry.Editor.ExecuteCommand(caBLOCKUND,0,false);
  end;

function TMainForm.GroupUndo:longint;
var
  Grouping     : Boolean;
  MemStackItem,
  StackItem,
  ItemType     : longint;
begin
  result := -1;
  if Assigned(FEdEntry) then
    with FEdEntry.Editor.UndoStack do begin
      Iterator(udia_INIT, StackItem);
      if Boolean(Iterator(udia_HAS_UNDO, StackItem)) then begin
        MemStackItem := StackItem;
        while Boolean(Iterator(udia_HAS_UNDO, StackItem))
           and (StackItem = MemStackItem) do begin
          Grouping := (StackItem = MemStackItem) and (
            (StackItem = ud_TYPING) or (StackItem = ud_DELETE));
          if Grouping
            then Iterator(udia_NEXT_UNDO or udia_GROUP, ItemType)
            else Iterator(udia_NEXT_UNDO, ItemType);
          end;
        result := ItemType;
        end
      end;
  end;

function TMainForm.GetUndoItem:longint;
var StackItem : longint;
begin
  result := -1;
  if Assigned(FEdEntry) then
    with FEdEntry.Editor.UndoStack do begin
      Iterator(udia_INIT, StackItem);
      if Boolean(Iterator(udia_HAS_UNDO, StackItem)) then
        result := StackItem;
      end;
  end;

function TMainForm.GroupRedo:longint;
var
  Grouping     : Boolean;
  MemStackItem,
  StackItem,
  ItemType     : longint;
begin
  result := -1;
  if Assigned(FEdEntry) then
    with FEdEntry.Editor.UndoStack do begin
      Iterator(udia_INIT, StackItem);
      if Boolean(Iterator(udia_HAS_REDO, StackItem)) then begin
        MemStackItem := StackItem;
        while Boolean(Iterator(udia_HAS_REDO, StackItem))
           and (StackItem = MemStackItem) do begin
          Grouping := (StackItem = MemStackItem) and (
            (StackItem = ud_TYPING) or (StackItem = ud_DELETE));
          if Grouping
            then Iterator(udia_NEXT_REDO or udia_GROUP, ItemType)
            else Iterator(udia_NEXT_REDO, ItemType);
          end;
        result := ItemType;
        end
      end;
  end;

function TMainForm.GetRedoItem:longint;
var StackItem : longint;
begin
  result := -1;
  if Assigned(FEdEntry) then
    with FEdEntry.Editor.UndoStack do begin
      Iterator(udia_INIT, StackItem);
      if Boolean(Iterator(udia_HAS_REDO, StackItem)) then
        result := StackItem;
      end;
  end;

procedure TMainForm.MEditClick(Sender: TObject);
const
  UndoActionNames : array[ud_DRAGDROP..ud_TEMPLATE] of string[20] =
  // List of basic TSyntaxMemo undo actions and English descriptions of each
    ('Drag/drop',           // ud_DRAGDROP
     'Typing',              // ud_TYPING
     'Delete',              // ud_DELETE
     'Paste',               // ud_PASTE
     'Cut',                 // ud_CUT
     'Template'             // ud_TEMPLATE
    );
var
  hs:boolean;
  XStackItem:longint;
begin
  XStackItem:=GetUndoItem;
  if XStackItem in [ud_DRAGDROP..ud_TEMPLATE] then
    EUndo.Caption := '&Undo ' + UndoActionNames[XStackItem]
  else EUndo.Caption := '&Undo';
  EUndo.Enabled := Assigned(FEdEntry) and (XStackItem<>-1); //}Boolean(FEdEntry.Editor.Perform(EM_CANUNDO, 0, 0));
  XStackItem:=GetRedoItem;
  if XStackItem in [ud_DRAGDROP..ud_TEMPLATE] then
    ERedo.Caption := '&Redo ' + UndoActionNames[XStackItem]
  else ERedo.Caption := '&Redo';
  EReDo.Enabled := Assigned(FEdEntry) and (XStackItem<>-1); //}Boolean(FEdEntry.Editor.Perform(SEM_CANREDO, 0, 0));
  hs :=  Assigned(FEdEntry) and (FEdEntry.Editor.SelLength<>0);
  ECut.Enabled     := hs;
  ECopy.Enabled    := hs;
  EPaste.Enabled   := Assigned(FEdEntry) and Clipboard.HasFormat(CF_TEXT);
  EIndent.Enabled  := hs;
  EUndent.Enabled  := hs;
  EConvSelCase.Enabled := hs;
  end;

procedure TMainForm.EUndoClick(Sender: TObject);
begin
  if Assigned(FEdEntry) then
    if OGroupedUndo.Checked
      then FEdEntry.Editor.UndoStack.ExecuteTo(GroupUndo,FEdEntry.Editor)
      else FEdEntry.Editor.ExecuteCommand(caUNDO,0,false);
  end;

procedure TMainForm.EReDoClick(Sender: TObject);
begin
  if Assigned(FEdEntry) then
    if OGroupedUndo.Checked
      then FEdEntry.Editor.UndoStack.ExecuteTo(GroupRedo,FEdEntry.Editor)
      else FEdEntry.Editor.ExecuteCommand(caREDO,0,false);
  end;

procedure TMainForm.MFileClick(Sender: TObject);
var hs:boolean;
begin
  hs := Assigned(FEdEntry);
  FReOpen.Enabled   := (ReOpenList.Count>0);
  FReLoad.Enabled   := hs;
  FSave.Enabled     := hs and FEdEntry.Editor.Modified;
  FSaveAs.Enabled   := hs;
  FSaveAll.Enabled  := hs and FWGetFilesModified;
  FClose.Enabled    := hs;
  FCloseAll.Enabled := hs;
  FPreviewInBrowser.Enabled := hs or (WebBrowser.Document<>nil);
  FConvertTextHTML.Enabled  := hs;
  FConvertTextRTF.Enabled   := hs;
  FPrint.Enabled    := hs;
  if FReOpen.Enabled then FWReOpenCreate;
  end;

procedure TMainForm.FReOpenFileOnClick(Sender: TObject);
begin
  FWReOpenFileClick((Sender as TMenuItem).Caption);
  end;

procedure TMainForm.FReLoadClick(Sender: TObject);
begin
  if Assigned(FEdEntry) then begin
    FWEditorLoadFile(FEdEntry,FEdEntry.FileName);
    HTMLMemoChange(nil);
    end;
  end;

procedure TMainForm.WStateClick(Sender: TObject);
begin
  if WindowState=wsMaximized then WindowState:=wsNormal
  else if WindowState=wsNormal then WindowState:=wsMaximized;
  end;

procedure TMainForm.WMActivateApp(var Message: TWMACTIVATEAPP);
begin
  if Assigned(FEdEntry) then FileWork.FWCmpAgeFiles;
  end;

procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
  procedure SaveParsers;
  var
    XSyntaxMemo:TSyntaxMemo;
    XFileStream:TFileStream;
    XStr:string;
  begin
    XStr:=ExtractFilePath(Application.ExeName);
    XSyntaxMemo:=TSyntaxMemo.Create(nil);
    XSyntaxMemo.Visible:=false;
    XSyntaxMemo.Parser1             := HTMLParser;
    XSyntaxMemo.Parser2             := PlainTextParser;
    XSyntaxMemo.Parser3             := SQLParser;
    XSyntaxMemo.ActiveParser:=1;
    XSyntaxMemo.Templates.SaveToFile(XStr+'HTMLParser.tpl');
    XFileStream:=TFileStream.Create(XStr+'HTMLParser.atr',fmCreate);
    XSyntaxMemo.AutoReplace.SaveToStream(XFileStream);
    XFileStream.Free;
    XSyntaxMemo.ActiveParser:=2;
    XSyntaxMemo.Templates.SaveToFile(XStr+'PlainTextParser.tpl');
    XFileStream:=TFileStream.Create(XStr+'PlainTextParser.atr',fmCreate);
    XSyntaxMemo.AutoReplace.SaveToStream(XFileStream);
    XFileStream.Free;
    XSyntaxMemo.ActiveParser:=3;
    XSyntaxMemo.Templates.SaveToFile(XStr+'SQLParser.tpl');
    XFileStream:=TFileStream.Create(XStr+'SQLParser.atr',fmCreate);
    XSyntaxMemo.AutoReplace.SaveToStream(XFileStream);
    XFileStream.Free;
    XSyntaxMemo.Free;
    end;

begin
  RegistrySave;
  SaveParsers;
  end;

procedure TMainForm.SettingsSetDefault;
begin
  WebBrowser.Offline:=true;
  EditorState:=esNorm;
  SplitterPercent := 75;
  ScrollBoxWidth := 800;
  ScrollBoxHeight := 600;
  ARDelay := 1500;
  B1BrName:=''; B1PathToBr:='';
  B2BrName:=''; B2PathToBr:='';
  B3BrName:=''; B3PathToBr:='';
  B4BrName:=''; B4PathToBr:='';
  ReOpenListMaxCnt := 15;
  FileWork.DelBakFiles := true;
  FileWork.HTMLDefaultExt := 'html';
  Files.DefParser:=1;
  Options.FShowLogo := true;
  SimpleImgToBr := false;
  DoNotBrNav := false;
  VScrollBox.Checked     :=not false; VScrollBoxClick(self);
  VStatusBar.Checked     :=not true;  VStatusBarClick(self);
  OAutoRefresh.Checked   :=not false; OAutoRefreshClick(self);
  OGroupedUndo.Checked   :=not true;  OGroupedUndoClick(self);
  OUndoAfterSave.Checked :=not true;  OUndoAfterSaveClick(self);
  with TitleFormat do begin
    PNVisible:=true; BFVisible:=true; EFVisible:=true;
    BFType:=bfTitle; EFType:=efFullPath;
    PNIncludeVersion:=false;
    PNFirst:=true;
    FFBrowser:=true;
    end;
  end;

procedure TMainForm.HHelpCurTagClick(Sender: TObject);
begin
  HelpWork.GetTagHelp;
  end;

procedure TMainForm.HTMLMemoSetFocus;
begin
  if Assigned(FEdEntry) then
    if FEdEntry.Editor.CanFocus then
      FEdEntry.Editor.SetFocus;
  end;

procedure TMainForm.WBSetFocus;
var memSBarPosX,memSBarPosY:integer;
begin
  memSBarPosX:=ScrollBox1.HorzScrollBar.Position;
  memSBarPosY:=ScrollBox1.VertScrollBar.Position;
  if WebBrowser.CanFocus then begin
    if ActiveOleControl=nil then begin
      ActiveOleControl:=WebBrowser;
      WebBrowser.DoObjectVerb(-4); //OLEIVERB_UIACTIVATE
      end;
    WebBrowser.SetFocus;
    end;
  ScrollBox1.HorzScrollBar.Position:=memSBarPosX;
  ScrollBox1.VertScrollBar.Position:=memSBarPosY;
  end;

procedure TMainForm.VChangeFocusClick(Sender: TObject);
begin
  if Assigned(FEdEntry) then
    if FEdEntry.Editor.Focused then WBSetFocus
    else HTMLMemoSetFocus;
  end;

procedure TMainForm.HTMLMemoChangeFocus(Sender: TObject);
begin
  if Assigned(FEdEntry) and (not FDoNotShowFocus) then
    Files.ShowEditorFocus(FEdEntry.Editor,FEdEntry.Editor.Focused);
  end;

procedure TMainForm.WebBrowserCommandStateChange(Sender: TObject;
  Command: Integer; Enable: WordBool);
begin
  if ActiveOleControl<>nil then WBSetFocus;
  case Command of
    CSC_NAVIGATEBACK: CNBack.Enabled := Enable;
    CSC_NAVIGATEFORWARD: CNForward.Enabled := Enable;
    end;
  end;

procedure TMainForm.FileTabsChanging(Sender: TObject;
  var AllowChange: Boolean);
begin
  AllowChange := false;
  end;

procedure TMainForm.MaxToolButtonClick(Sender: TObject);
begin
  if EditorState<>esMax then begin
    if EditorState=esNorm then
      memHTMLMemoFocus:= Assigned(FEdEntry) and FEdEntry.Editor.Focused;
    HTMLMemoSetFocus;
    Splitter1.Visible:=false;
    HTMLPanel.Visible:=true;
    Splitter1.Align:=alNone;
    ScrollBox1.Align:=alNone;
    HTMLPanel.Align:=alClient;
    ScrollBox1.Visible:=false;
    MinToolButton.ImageIndex:=0;
    MaxToolButton.ImageIndex:=3;
    EditorState:=esMax;
    MaxToolButton.Hint:='Restore';
  end else begin
    EditorState:=esNorm;
    ScrollBox1.Visible:=true;
    if memHTMLMemoFocus then HTMLMemoSetFocus
    else WBSetFocus;
    FormResize(self);
    MaxToolButton.ImageIndex:=1;
    MaxToolButton.Hint:='Maximize';
    end;
  end;

procedure TMainForm.MinToolButtonClick(Sender: TObject);
var OldHeight,NewHeight:integer;
begin
  if EditorState<>esMin then begin
    if EditorState=esNorm then
      memHTMLMemoFocus:= Assigned(FEdEntry) and FEdEntry.Editor.Focused;
    OldHeight:=HTMLPanel.Height;
    NewHeight:=FileTabs.Top+FileTabs.Height;
    Splitter1.Visible:=false;
    ScrollBox1.Visible:=true;
    Splitter1.Align:=alNone;
    ScrollBox1.Align:=alNone;
    HTMLPanel.Align:=alNone;
    StatusBar1.Align:=alNone;
    HTMLPanel.Height:=NewHeight;
    HTMLPanel.Top:=HTMLPanel.Top+(OldHeight-NewHeight);
    StatusBar1.Align:=alBottom;
    HTMLPanel.Align:=alBottom;
    ScrollBox1.Align:=alClient;
    MaxToolButton.ImageIndex:=1;
    MinToolButton.ImageIndex:=3;
    WBSetFocus;
    EditorState:=esMin;
    MinToolButton.Hint:='Restore';
  end else begin
    EditorState:=esNorm;
    if memHTMLMemoFocus then HTMLMemoSetFocus
    else WBSetFocus;
    FormResize(self);
    MinToolButton.ImageIndex:=0;
    MinToolButton.Hint:='Minimize';
    end;
  end;

procedure TMainForm.WebBrowserExit(Sender: TObject);
begin
  if Assigned(FEdEntry) then begin
    if not FEdEntry.Editor.Focused then HTMLMemoSetFocus;
    if not FEdEntry.Editor.Focused then WBSetFocus;
    end;
  end;

procedure TMainForm.MViewClick(Sender: TObject);
var
  hs,bs:boolean;
begin
  hs:=Assigned(FEdEntry);
  bs:=(WebBrowser.Document<>nil);
  VChangeFocus.Enabled         :=hs and bs and (EditorState=esNorm);
  VRefresh.Enabled             :=bs;
  VSaveNRefresh.Enabled        :=hs and bs;
  VSaveAndToBrowser.Enabled    :=hs;
  VSaveAllAndRefresh.Enabled   :=hs and bs;
  OAutoRefresh.Enabled         :=hs;
  VWorkOffline.Checked         :=WebBrowser.Offline;
  end;

procedure TMainForm.FCloseClick(Sender: TObject);
begin
  FileWork.FWCloseFile;
  end;

procedure TMainForm.FCloseAllClick(Sender: TObject);
begin
  FileWork.CloseAllFiles;
  end;

procedure TMainForm.toBrowserToolButtonClick(Sender: TObject);
begin
  if Assigned(FEdEntry) then WBrowserNavigate(FEdEntry.FileName);
  end;

function TMainForm.GetBrFileName(ALocationURL:string):string;
//result='' - error
var
  XStr:string;
  XPos:integer;
begin
  XStr:=ALocationURL;
  if copy(XStr,0,8)='file:///' then begin
    XStr:=StringReplace(Copy(XStr,9,length(XStr)-8),'/','\',[rfReplaceAll]);
    XStr:=StringReplace(XStr,'%20',#32,[rfReplaceAll]);
    XPos:=Pos('#',XStr);
    if XPos>0 then XStr:=Copy(XStr,1,XPos-1);
    XPos:=Pos('?',XStr);
    if XPos>0 then XStr:=Copy(XStr,1,XPos-1);
    result:=XStr;
  end else result:='';
  end;

procedure TMainForm.toEditorToolButtonClick(Sender: TObject);
var XStr:string;
begin
  XStr:=GetBrFileName(WebBrowser.LocationURL);
  if XStr<>'' then LoadFileName(XStr)
  else MessageDlg('Cannot location "'+WebBrowser.LocationURL+
                  '" convert to file name.', mtError, [mbOk], 0);
  end;

procedure TMainForm.OEditorOptionsClick(Sender: TObject);
begin
  if Assigned(FEdEntry) then begin
    FEdEntry.Editor.Lines.BeginUpdate;
    FEdEntry.Editor.ModifyProperties;
    Files.ShowEditorFocus(FEdEntry.Editor,FEdEntry.Editor.Focused);
    Files.FFirst:=true; //refresh StatusBar1
    HTMLMemoChange(self);
    FEdEntry.Editor.Lines.EndUpdate;        
    end
  end;

procedure TMainForm.MOptionsClick(Sender: TObject);
var an:boolean;
begin
  an:=Assigned(FEdEntry);
  OEditorOptions.Enabled := an;
  OGroupedUndo.Enabled   := an;
  OUndoAfterSave.Enabled := an;
  OParser.Enabled        := an;
  OWordWrap.Checked := an and FEdEntry.Editor.WordWrap;
  end;

procedure TMainForm.OParserChangeClick(Sender: TObject);
begin
  if Assigned(FEdEntry) then begin
    FEdEntry.Editor.Lines.BeginUpdate;
    FEdEntry.Editor.ActiveParser:=StrToInt(TMenuItem(Sender).Name[3]);
    Files.ShowEditorFocus(FEdEntry.Editor,FEdEntry.Editor.Focused);
    Files.FFirst:=true; //refresh StatusBar1
    HTMLMemoChange(self);
    FEdEntry.Editor.Lines.EndUpdate;
    end;
  end;

procedure TMainForm.OParserClick(Sender: TObject);
begin
  case FEdEntry.Editor.ActiveParser of
    1:begin
      OP1WebDocuments.Checked:=true;
      OP2Plaintext.Checked:=false;
      OP3SQL.Checked:=false;
      end;
    2:begin
      OP1WebDocuments.Checked:=false;
      OP2Plaintext.Checked:=true;
      OP3SQL.Checked:=false;
      end;
    3:begin
      OP1WebDocuments.Checked:=false;
      OP2Plaintext.Checked:=false;
      OP3SQL.Checked:=true;
      end;
    end;
  end;

procedure TMainForm.MHelpClick(Sender: TObject);
begin
  HHelpIndex.Enabled  := not HelpWork.HelpIniError;
  HHelpCurTag.Enabled := Assigned(FEdEntry)and (not HelpWork.HelpIniError);
  end;

procedure TMainForm.CSClick(Sender: TObject);
begin
  SetTabNum(StrToInt((Sender as TMenuItem).Name[3]));
  end;

procedure TMainForm.EDeleteLineClick(Sender: TObject);
begin
  if Assigned(FEdEntry) then
    FEdEntry.Editor.ExecuteCommand(caDELETELINE,0,false);
  end;

procedure TMainForm.ECUpperClick(Sender: TObject);
begin
  if Assigned(FEdEntry) then
    with FEdEntry.Editor do SelText := Uppercase(SelText);
  end;

procedure TMainForm.ECLowerClick(Sender: TObject);
begin
  if Assigned(FEdEntry) then
    with FEdEntry.Editor do SelText := Lowercase(SelText);
  end;

procedure TMainForm.FConvertTextClick(Sender: TObject);
begin
  FWConvertText(Sender);
  end;

procedure TMainForm.HTMLMemoNotification(AEditor:TSyntaxMemo;AOperation:TOperation);
begin
  if Assigned(FEdEntry) then
    Notification(FEdEntry.Editor,AOperation);
  end;

procedure TMainForm.HTMLMemoCommandRecognised(Sender: TObject;
  var ActionCode: Integer);
begin
  if ActionCode=integer(caUndo) then begin
    EUndoClick(self);
    ActionCode := -1;
    end;
  if ActionCode=integer(caRedo) then begin
    ERedoClick(self);
    ActionCode := -1;
    end;
  end;

procedure TMainForm.OGroupedUndoClick(Sender: TObject);
begin
  OGroupedUndo.Checked := not OGroupedUndo.Checked;
  end;

procedure TMainForm.HHelpSettingClick(Sender: TObject);
begin
  SetHelpForm.ShowModal;
  HelpWork.HelpIniLoad;
  end;

procedure TMainForm.FSaveAllClick(Sender: TObject);
begin
  FWSaveAll;
  end;

procedure TMainForm.FPPrintAllClick(Sender: TObject);
begin
  if Assigned(FEdEntry) then
    FEdEntry.Editor.Print;
  end;

procedure TMainForm.FPPrintSelectedBlockClick(Sender: TObject);
begin
  if Assigned(FEdEntry) then
    FEdEntry.Editor.PrintSelection;
  end;

procedure TMainForm.FPrintClick(Sender: TObject);
begin
  FPPrintSelectedBlock.Enabled:=(FEdEntry.Editor.SelLength<>0);
  end;

procedure TMainForm.CMUpClick(Sender: TObject);
begin
  if EditorState=esNorm then with HtmlPanel do
    if ScrollBox1.Height-10>90 then begin
      Height:=Height+10; Splitter1Moved(self);
      end;
  end;

procedure TMainForm.CMDownClick(Sender: TObject);
begin
  if EditorState=esNorm then with HtmlPanel do
    if Height-10>30 then begin
      Height:=Height-10; Splitter1Moved(self);
      end;
  end;

procedure TMainForm.CSPrevClick(Sender: TObject);
begin
  if Assigned(FEdEntry) then begin
    Files.FileTabsChanging;
    if FileTabs.TabIndex=0 then FileTabs.TabIndex:=FileTabs.Tabs.Count-1
    else FileTabs.TabIndex:=FileTabs.TabIndex-1;
    Files.FileTabsChange;
    end;
  end;

procedure TMainForm.CSNextClick(Sender: TObject);
begin
  if Assigned(FEdEntry) then begin
    Files.FileTabsChanging;
    if FileTabs.TabIndex=FileTabs.Tabs.Count-1 then FileTabs.TabIndex:=0
    else FileTabs.TabIndex:=FileTabs.TabIndex+1;
    Files.FileTabsChange;
    end;
  end;

procedure TMainForm.CMoveSBoxClick(Sender: TObject);
begin
  if VScrollBox.Checked then begin
    with ScrollBox1.VertScrollBar do
      if Sender = CBUp then Position:=Position-(ScrollBox1.Height div 10)
      else if Sender = CBDown then Position:=Position+(ScrollBox1.Height div 10)
      else if Sender = CBPgUp then Position:=Position-(ScrollBox1.Height-ScrollBox1.Height div 10)
      else if Sender = CBPgDn then Position:=Position+(ScrollBox1.Height-ScrollBox1.Height div 10)
      else if Sender = CBHome then Position:=0
      else if Sender = CBEnd then Position:=Range;
    with ScrollBox1.HorzScrollBar do
      if Sender = CBHorzLeft then Position:=Position-(ScrollBox1.Width div 10)
      else if Sender = CBHorzRight then Position:=Position+(ScrollBox1.Width div 10)
      else if Sender = CBHorzPgUp then Position:=Position-(ScrollBox1.Width-ScrollBox1.Width div 10)
      else if Sender = CBHorzPgDn then Position:=Position+(ScrollBox1.Width-ScrollBox1.Width div 10)
      else if Sender = CBHorzHome then Position:=0
      else if Sender = CBHorzEnd then Position:=Range;
    end;
  end;

procedure TMainForm.CTMoveCurByTagsClick(Sender: TObject);
var
  iMem,XLenStr:integer;
  i,XStart,XLength:integer;
  XStr:string;
begin
  if Assigned(FEdEntry) and FEdEntry.Editor.Focused then with FEdEntry.Editor do
    if (Sender=CTLeft)or(Sender=CTSelLeft)or(Sender=CTMoveSelLeft) then begin
      XStart:=SelStart;
      XLength:=SelLength;
      XStr:=Lines.Text;
      i:=XStart;
      while (i>1)and(XStr[i-1]<>'>')and(XStr[i]<>'<') do dec(i);
      if i>0 then begin
        if Sender=CTLeft then SelStart:=i-1;
        if (Sender=CTSelLeft) then begin
          Lines.BeginUpdate;
          SelStart:=i-1;
          SelLength:=XLength+XStart-(i-1);
          Lines.EndUpdate;
          end;
        if (Sender=CTMoveSelLeft) then begin
          SelStart:=i-1;
          SelLength:=XStart-(i-1);
          end;
        end;
      end
    else if (Sender=CTRight)or(Sender=CTSelRight)or(Sender=CTMoveSelRight) then begin
      XStart:=SelStart;
      XLength:=SelLength;
      XStr:=Lines.Text;
      XLenStr:=Length(XStr);
      i:=XStart+1+XLength;
      iMem:=i;
      while (i<=XLenStr)and(XStr[i]<>'>')and(XStr[i+1]<>'<') do inc(i);
      if (i<=XLenStr) then
        if (Sender=CTSelRight)or(Sender=CTMoveSelRight) then
          if (Sender=CTMoveSelRight) then begin
            SelStart:=iMem-1;
            SelLength:=i-SelStart;
          end else SelLength:=i-XStart
        else SelStart:=i;
      end;
  end;

procedure TMainForm.COpenFileUnderCursorClick(Sender: TObject);
var
  i1,i2:integer;
  XStr,XFile:string;
  EndChars,LEndChars,REndChars:set of char;
begin
  if Assigned(FEdEntry) and FEdEntry.Editor.Focused then begin
    EndChars:=['"','''',#32,#9,#13,'<','>','(',')'];
    if (Sender=COEditor)or(Sender=COBrowser) then EndChars:=EndChars+['#','?'];
    LEndChars:=EndChars+['='];
    REndChars:=EndChars;
    if FEdEntry.Editor.SelLength=0 then with FEdEntry.Editor do begin
      XStr:=Lines.Text;
      i1:=SelStart+1; i2:=i1;
      while ((i1-1)>0)and(not (XStr[i1-1] in LEndChars)) do dec(i1);
      while (i2<=Length(XStr))and(not (XStr[i2] in REndChars)) do inc(i2);
      if i1=i2 then begin
        MessageDlg('Where do you see a file?', mtError, [mbOk], 0);
        exit;
        end;
      XFile:=Copy(XStr,i1,i2-i1);
    end else XFile:=FEdEntry.Editor.SelText;
    if (Sender=COEditor)or(Sender=COBrowser) then begin
      XFile:=StringReplace(XFile,'/','\',[rfReplaceAll]);
      XFile:=StringReplace(XFile,'%20',#32,[rfReplaceAll]);
      XFile:=ExpandFileName(ExtractFilePath(FEdEntry.FileName)+XFile);
      if FileWork.FWFileExists(XFile) then begin
        if Sender=COEditor then FileWork.LoadFileName(XFile);
        if Sender=COBrowser then begin
          XStr:=UpperCase(ExtractFileExt(XFile));
          if (not SimpleImgToBr) and ((XStr='.GIF')or(XStr='.JPG')or(XStr='.JPEG')or(XStr='.PNG')) then begin
            XStr:=ExtractFilePath(Application.ExeName)+'image.html';
            if FileExists(XStr) then begin
              WBrowserNavigate('file:///'+XStr+'?file:///'+XFile);
            end else begin
              MessageDlg('Can not find "'+XStr+'"', mtError, [mbOk], 0);
              exit;
              end;
          end else WBrowserNavigate(XFile);
          end;
        end;
      end;
    if Sender=COShell then ShellExec(ExtractFilePath(FEdEntry.FileName),XFile,'');
    end;
  end;

procedure TMainForm.CBrowserNavigateClick(Sender: TObject);
begin
  if WebBrowser.Document<>nil then begin
    if Sender=CNBack then WebBrowser.GoBack;
    if Sender=CNForward then WebBrowser.GoForward;
    end;
  end;

procedure TMainForm.FBBrNameClick(Sender: TObject);
begin
  if Assigned(FEdEntry) then begin
    if Sender=FB1BrName then ShellExec('',B1PathToBr,FEdEntry.FileName);
    if Sender=FB2BrName then ShellExec('',B2PathToBr,FEdEntry.FileName);
    if Sender=FB3BrName then ShellExec('',B3PathToBr,FEdEntry.FileName);
    if Sender=FB4BrName then ShellExec('',B4PathToBr,FEdEntry.FileName);
    if Sender=FB1BrNameWeb then ShellExec('',B1PathToBr,WebBrowser.LocationURL);
    if Sender=FB2BrNameWeb then ShellExec('',B2PathToBr,WebBrowser.LocationURL);
    if Sender=FB3BrNameWeb then ShellExec('',B3PathToBr,WebBrowser.LocationURL);
    if Sender=FB4BrNameWeb then ShellExec('',B4PathToBr,WebBrowser.LocationURL);
    end;
  end;

function TMainForm.ShellExec(ADir,AFile,APar:string):boolean;
var
  eCode:integer;
  eMsg:string;
begin
  result:=false;
  eCode:=ShellAPI.ShellExecute(0,nil,PChar(AFile),PChar(APar),PChar(ADir),SW_SHOWDEFAULT);
  if eCode<32 then begin
    case eCode of
      0:                     eMsg:='The operating system is out of memory or resources.';
      ERROR_FILE_NOT_FOUND:  eMsg:='The specified file was not found.';
      ERROR_PATH_NOT_FOUND:  eMsg:='The specified path was not found.';
      ERROR_BAD_FORMAT:      eMsg:='The .EXE file is invalid (non-Win32 .EXE or error in .EXE image).';
      SE_ERR_ACCESSDENIED:   eMsg:='The operating system denied access to the specified file. ';
      SE_ERR_ASSOCINCOMPLETE:eMsg:='The filename association is incomplete or invalid.';
      SE_ERR_DDEBUSY:        eMsg:='The DDE transaction could not be completed because other DDE transactions were being processed.';
      SE_ERR_DDEFAIL:        eMsg:='The DDE transaction failed.';
      SE_ERR_DDETIMEOUT:     eMsg:='The DDE transaction could not be completed because the request timed out.';
      SE_ERR_DLLNOTFOUND:    eMsg:='The specified dynamic-link library was not found. ';
      SE_ERR_NOASSOC:        eMsg:='There is no application associated with the given filename extension.';
      SE_ERR_OOM:            eMsg:='There was not enough memory to complete the operation.';
      SE_ERR_SHARE:          eMsg:='A sharing violation occurred.';
      else eMsg:='';
      end;
    MessageDlg('FileName: '''+AFile+''''+#13+
               'Path: '''+ADir+''''+#13+#13+
               'Error code: '+IntToStr(eCode)+' ('+eMsg+')', mtError, [mbOk], 0);
    exit;
    end;
  result:=true;
  end;

procedure TMainForm.FPreviewinBrowserClick(Sender: TObject);
var
  XB1,XB2,XB3,XB4:boolean;
begin
  XB1:=(B1BrName<>'');
  XB2:=(B2BrName<>'');
  XB3:=(B3BrName<>'');
  XB4:=(B4BrName<>'');
  FBDefaultBrowser1.Enabled:=Assigned(FEdEntry);
  if XB1 then FB1BrName.Caption:='(Text) Browser1: '+B1BrName;
  if XB2 then FB2BrName.Caption:='(Text) Browser2: '+B2BrName;
  if XB3 then FB3BrName.Caption:='(Text) Browser3: '+B3BrName;
  if XB4 then FB4BrName.Caption:='(Text) Browser4: '+B4BrName;
  FB1BrName.Visible:=XB1; FB1BrName.Enabled:=XB1 and Assigned(FEdEntry);
  FB2BrName.Visible:=XB2; FB2BrName.Enabled:=XB2 and Assigned(FEdEntry);
  FB3BrName.Visible:=XB3; FB3BrName.Enabled:=XB3 and Assigned(FEdEntry);
  FB4BrName.Visible:=XB4; FB4BrName.Enabled:=XB4 and Assigned(FEdEntry);
  FBDefaultBrowser1Web.Enabled:=WebBrowser.Document<>nil;
  if XB1 then FB1BrNameWeb.Caption:='(Web) Browser1: '+B1BrName;
  if XB2 then FB2BrNameWeb.Caption:='(Web) Browser2: '+B2BrName;
  if XB3 then FB3BrNameWeb.Caption:='(Web) Browser3: '+B3BrName;
  if XB4 then FB4BrNameWeb.Caption:='(Web) Browser4: '+B4BrName;
  FB1BrNameWeb.Visible:=XB1; FB1BrNameWeb.Enabled:=XB1 and (WebBrowser.Document<>nil);
  FB2BrNameWeb.Visible:=XB2; FB2BrNameWeb.Enabled:=XB2 and (WebBrowser.Document<>nil);
  FB3BrNameWeb.Visible:=XB3; FB3BrNameWeb.Enabled:=XB3 and (WebBrowser.Document<>nil);
  FB4BrNameWeb.Visible:=XB4; FB4BrNameWeb.Enabled:=XB4 and (WebBrowser.Document<>nil);
  end;

procedure TMainForm.FBDefaultBrowser1Click(Sender: TObject);
begin
  ShellExec('',FEdEntry.FileName,'');
  end;

procedure TMainForm.FBDefaultBrowser1WebClick(Sender: TObject);
begin
  ShellExec('',WebBrowser.LocationURL,'');
  end;

procedure TMainForm.FBEditBrowserListClick(Sender: TObject);
begin
  OptForm.OptPageControl.ActivePage:=OptForm.BrowsersTabSheet;
  OptForm.ShowModal;
  end;

procedure TMainForm.SGotoLineNumberClick(Sender: TObject);
var
  XStr:string;
  XInt,XCode:integer;
begin
  if Assigned(FEdEntry) then begin
    XStr:=IntToStr(FEdEntry.Editor.CaretPosition.Row);
    repeat
      XInt:=0;
      if not InputQuery('Go to line number','Enter new line number (1-'+
                        IntToStr(FEdEntry.Editor.Lines.Count)+')',XStr) then break;
      val(XStr,XInt,XCode);
      if (XCode=0) and (XInt>=1) and (XInt<=FEdEntry.Editor.Lines.Count) then break
      else MessageDlg('Value must be between 1 and '+
                      IntToStr(FEdEntry.Editor.Lines.Count), mtError, [mbOk], 0);
      until false;
    if XInt<>0 then FEdEntry.Editor.CaretPosition.Row:=XInt;
    end;
  end;

procedure TMainForm.OUndoAfterSaveClick(Sender: TObject);
begin
  OUndoAfterSave.Checked := not OUndoAfterSave.Checked;
  end;

function TMainForm.HTMLMemofn_CmpChar(c: Char): Boolean;
//fn_CharIsInWord	Test if a character can be in a word
//fn_CharStartsWord	Test if a character can start a word
begin
  result:=(c in ['A'..'Z','a'..'z',''..'',''..'','0'..'9','_']);
  end;

procedure TMainForm.FileTabsMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var XInt:integer;
begin
  XInt:=FileTabs.IndexOfTabAt(X,Y);
  if (XInt<>-1) then
    if Button=mbLeft then
      if (ssShift in Shift) then begin
        FileTabs.Tabs.Move(FileTabs.TabIndex,XInt);
        FileTabs.TabIndex:=XInt;
      end else begin
        Files.FileTabsChanging;
        FileTabs.TabIndex:=XInt;
        Files.FileTabsChange;
        end;
  end;

procedure TMainForm.FileTabsMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var XInt:integer;
begin
  XInt:=FileTabs.IndexOfTabAt(X,Y);
  if (XInt<>-1) then
    if Button=mbRight then FileWork.FWOpenText(XInt);
  end;

procedure TMainForm.FileTabsMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
var
  XInt:integer;
  XStr:string;
begin
  XInt:=FileTabs.IndexOfTabAt(X,Y);
  XStr:=FileTabs.Hint;
  if  XInt<>-1
    then FileTabs.Hint:=TEditorEntry(FileTabs.Tabs.Objects[XInt]).FileName
    else FileTabs.Hint:='';
  if (FileTabs.Hint<>XStr) then begin
    Application.HideHint;
    if (FileTabs.Hint<>'') then
      Application.ActivateHint(FileTabs.ClientToScreen(Point(X,Y)));
    end;
  end;

procedure TMainForm.CMFilePrevClick(Sender: TObject);
var XInt:integer;
begin
  if Assigned(FEdEntry) then begin
    if FileTabs.TabIndex=0 then XInt:=FileTabs.Tabs.Count-1
    else XInt:=FileTabs.TabIndex-1;
    FileTabs.Tabs.Move(FileTabs.TabIndex,XInt);
    FileTabs.TabIndex:=XInt;
    end;
  end;

procedure TMainForm.CMFileNextClick(Sender: TObject);
var XInt:integer;
begin
  if Assigned(FEdEntry) then begin
    if FileTabs.TabIndex=FileTabs.Tabs.Count-1 then XInt:=0
    else XInt:=FileTabs.TabIndex+1;
    FileTabs.Tabs.Move(FileTabs.TabIndex,XInt);
    FileTabs.TabIndex:=XInt;
    end;
  end;

procedure TMainForm.HHelpIndexClick(Sender: TObject);
begin
  HelpWork.GetHelpIndex;
  end;

procedure TMainForm.MShortCutClick(Sender: TObject);
var ea:boolean;
begin
  ea:=Assigned(FEdEntry);
  OWordWrap.Enabled            := ea;
  OShowAllChars.Enabled        := ea;
  CtoBrowserToolButton.Enabled := toBrowserToolButton.Enabled;
  CtoEditorToolButton.Enabled  := toEditorToolButton.Enabled;
  CMoveFile.Enabled            := ea and (FileTabs.Tabs.Count>1);
  CSetTab.Enabled              := ea and (FileTabs.Tabs.Count>1);
  CMoveSplitter.Enabled        := (EditorState=esNorm);
  CMoveScrollBox.Enabled       := VScrollBox.Checked;
  CMoveCursorByTags.Enabled    := ea;
  COpenFileUnderCursor.Enabled := ea;
  CBrowserNavigate.Enabled     := (WebBrowser.Document<>nil) and
                                  (CNBack.Enabled or CNForward.Enabled);
  end;

procedure TMainForm.CSetTabClick(Sender: TObject);
begin
  CS1.Enabled:=FileTabs.Tabs.Count>0;
  CS2.Enabled:=FileTabs.Tabs.Count>1;
  CS3.Enabled:=FileTabs.Tabs.Count>2;
  CS4.Enabled:=FileTabs.Tabs.Count>3;
  CS5.Enabled:=FileTabs.Tabs.Count>4;
  CS6.Enabled:=FileTabs.Tabs.Count>5;
  CS7.Enabled:=FileTabs.Tabs.Count>6;
  CS8.Enabled:=FileTabs.Tabs.Count>7;
  CS9.Enabled:=FileTabs.Tabs.Count>8;
  end;

procedure TMainForm.EditorPopupMenuPopup(Sender: TObject);
var hs:boolean;
begin
  hs :=  Assigned(FEdEntry) and (FEdEntry.Editor.SelLength<>0);
  PCut.Enabled     := hs;
  PCopy.Enabled    := hs;
  PPaste.Enabled   := Assigned(FEdEntry) and Clipboard.HasFormat(CF_TEXT);
  end;

procedure TMainForm.OShowAllCharsClick(Sender: TObject);
begin
  if Assigned(FEdEntry) then with FEdEntry.Editor do
    if smoShowAllChars in Options
      then Options:=Options - [smoShowAllChars]
      else Options:=Options + [smoShowAllChars];
  end;

procedure TMainForm.VWorkOfflineClick(Sender: TObject);
begin
  VWorkOffline.Checked:= not VWorkOffline.Checked;
  WebBrowser.Offline:=VWorkOffline.Checked;
  end;

procedure TMainForm.CStatusBarToClipboardClick(Sender: TObject);
var XClipBoard:TClipBoard;
begin
  XClipBoard:=ClipBoard;
  XClipBoard.SetTextBuf(PChar(Statusbar1.Panels[3].Text));
  end;

end.

